# mypy-boto3-kinesis

[![PyPI - mypy-boto3-kinesis](https://img.shields.io/pypi/v/mypy-boto3-kinesis.svg?color=blue)](https://pypi.org/project/mypy-boto3-kinesis)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-kinesis.svg?color=blue)](https://pypi.org/project/mypy-boto3-kinesis)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.Kinesis 1.12.23](https://boto3.amazonaws.com/v1/documentation/api/1.12.23/reference/services/kinesis.html#Kinesis) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 1.0.5](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-kinesis](#mypy-boto3-kinesis)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

### Type checking

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Kinesis` service.

```bash
python -m pip install boto3-stubs[mypy-boto3-kinesis]
```

Use `boto3` with `mypy_boto3` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3 import kinesis
# alternative import if you do not want to install mypy_boto3 package
# import mypy_boto3_kinesis as kinesis

# Use this client as usual, now mypy can check if your code is valid.
# Check if your IDE supports function overloads,
# you probably do not need explicit type annotations
# client = boto3.client("kinesis")
client: kinesis.KinesisClient = boto3.client("kinesis")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: kinesis.KinesisClient = session.client("kinesis")


# Waiters need type annotation on creation
stream_exists_waiter: kinesis.StreamExistsWaiter = client.get_waiter("stream_exists")
stream_not_exists_waiter: kinesis.StreamNotExistsWaiter = client.get_waiter("stream_not_exists")

# Paginators need type annotation on creation
describe_stream_paginator: kinesis.DescribeStreamPaginator = client.get_paginator("describe_stream")
list_shards_paginator: kinesis.ListShardsPaginator = client.get_paginator("list_shards")
list_stream_consumers_paginator: kinesis.ListStreamConsumersPaginator = client.get_paginator("list_stream_consumers")
list_streams_paginator: kinesis.ListStreamsPaginator = client.get_paginator("list_streams")
```

## How it works

Fully automated [builder](https://github.com/vemel/mypy_boto3_builder) carefully generates
type annotations for each service, patiently waiting for `boto3` updates. It delivers
a drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type annotations
  extracted from the documentation (blame `botocore` docs if types are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) for readability.